#include <Carbon/Carbon.r>

#define Reserved8   reserved, reserved, reserved, reserved, reserved, reserved, reserved, reserved
#define Reserved12  Reserved8, reserved, reserved, reserved, reserved
#define Reserved13  Reserved12, reserved
#define dp_none__   noParams, "", directParamOptional, singleItem, notEnumerated, Reserved13
#define reply_none__   noReply, "", replyOptional, singleItem, notEnumerated, Reserved13
#define synonym_verb__ reply_none__, dp_none__, { }
#define plural__    "", {"", kAESpecialClassProperties, cType, "", reserved, singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural}, {}

resource 'aete' (0, "") {
	0x1,  // major version
	0x0,  // minor version
	english,
	roman,
	{
		"Standard Suite",
		"Common classes and commands for most applications.",
		'????',
		1,
		1,
		{
			/* Events */

			"open",
			"Open an object.",
			'aevt', 'odoc',
			reply_none__,
			'file',
			"The file(s) to be opened.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"print",
			"Print an object.",
			'aevt', 'pdoc',
			reply_none__,
			'file',
			"The file(s) or document(s) to be printed.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"quit",
			"Quit an application.",
			'aevt', 'quit',
			reply_none__,
			dp_none__,
			{
				"saving", 'savo', 'savo',
				"Specifies whether changes should be saved before quitting.",
				optional,
				singleItem, enumerated, Reserved13
			},

			"close",
			"Close an object.",
			'core', 'clos',
			reply_none__,
			'obj ',
			"the object to close",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"saving", 'savo', 'savo',
				"Specifies whether changes should be saved before closing.",
				optional,
				singleItem, enumerated, Reserved13,
				"saving in", 'kfil', 'file',
				"The file in which to save the object.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"count",
			"Return the number of elements of a particular class within an object.",
			'core', 'cnte',
			'long',
			"the number of elements",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object whose elements are to be counted",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"each", 'kocl', 'type',
				"The class of objects to be counted.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"delete",
			"Delete an object.",
			'core', 'delo',
			reply_none__,
			'obj ',
			"the object to delete",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"duplicate",
			"Copy object(s) and put the copies at a new location.",
			'core', 'clon',
			reply_none__,
			'obj ',
			"the object(s) to duplicate",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"The location for the new object(s).",
				required,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"Properties to be set in the new duplicated object(s).",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"exists",
			"Verify if an object exists.",
			'core', 'doex',
			'bool',
			"true if it exists, false if not",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object in question",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"get",
			"Get the data for an object.",
			'core', 'getd',
			'****',
			"",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"make",
			"Make a new object.",
			'core', 'crel',
			'obj ',
			"to the new object",
			replyRequired, singleItem, notEnumerated, Reserved13,
			dp_none__,
			{
				"new", 'kocl', 'type',
				"The class of the new object.",
				required,
				singleItem, notEnumerated, Reserved13,
				"at", 'insh', 'insl',
				"The location at which to insert the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with data", 'data', '****',
				"The initial data for the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"The initial values for properties of the object.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"move",
			"Move object(s) to a new location.",
			'core', 'move',
			reply_none__,
			'obj ',
			"the object(s) to move",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"The new location for the object(s).",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"save",
			"Save an object.",
			'core', 'save',
			reply_none__,
			'obj ',
			"the object to save, usually a document or window",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"in", 'kfil', 'file',
				"The file in which to save the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"as", 'fltp', 'TEXT',
				"The file type in which to save the data.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"set",
			"Set an object's data.",
			'core', 'setd',
			reply_none__,
			'obj ',
			"",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'data', '****',
				"The new value.",
				required,
				singleItem, notEnumerated, Reserved13
			}
		},
		{
			/* Classes */

			"item", 'cobj',
			"A scriptable object.",
			{
				"class", 'pcls', 'type',
				"The class of the object.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"properties", 'pALL', 'reco',
				"All of the object's properties.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"items", 'cobj', plural__,

			"application", 'capp',
			"An application's top level scripting object.",
			{
				"name", 'pnam', 'TEXT',
				"The name of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"frontmost", 'pisf', 'bool',
				"Is this the frontmost (active) application?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"version", 'vers', 'TEXT',
				"The version of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'docu', { },
				'cwin', { }
			},
			"applications", 'capp', plural__,

			"color", 'colr',
			"A color.",
			{
			},
			{
			},
			"colors", 'colr', plural__,

			"document", 'docu',
			"A document.",
			{
				"path", 'ppth', 'TEXT',
				"The document's path.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"modified", 'imod', 'bool',
				"Has the document been modified since the last save?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"name", 'pnam', 'TEXT',
				"The document's name.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"documents", 'docu', plural__,

			"window", 'cwin',
			"A window.",
			{
				"name", 'pnam', 'TEXT',
				"The full title of the window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"id", 'ID  ', 'nmbr',
				"The unique identifier of the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"bounds", 'pbnd', 'qdrt',
				"The bounding rectangle of the window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"document", 'docu', 'docu',
				"The document whose contents are being displayed in the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"closeable", 'hclb', 'bool',
				"Whether the window has a close box.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"titled", 'ptit', 'bool',
				"Whether the window has a title bar.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"index", 'pidx', 'nmbr',
				"The index of the window in the back-to-front window ordering.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"floating", 'isfl', 'bool',
				"Whether the window floats.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"miniaturizable", 'ismn', 'bool',
				"Whether the window can be miniaturized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"miniaturized", 'pmnd', 'bool',
				"Whether the window is currently miniaturized.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"modal", 'pmod', 'bool',
				"Whether the window is the application's current modal window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"resizable", 'prsz', 'bool',
				"Whether the window can be resized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"visible", 'pvis', 'bool',
				"Whether the window is currently visible.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"zoomable", 'iszm', 'bool',
				"Whether the window can be zoomed.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"zoomed", 'pzum', 'bool',
				"Whether the window is currently zoomed.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"windows", 'cwin', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'savo',
			{
				"yes", 'yes ', "Save the file.",
				"no", 'no  ', "Do not save the file.",
				"ask", 'ask ', "Ask the user whether or not to save the file."
			}
		},

		"Text Suite",
		"A set of basic classes for text processing.",
		'????',
		1,
		1,
		{
			/* Events */

		},
		{
			/* Classes */

			"text", 'ctxt',
			"Rich (styled) text",
			{
				"color", 'colr', 'colr',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'nmbr',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cpar', { },
				'cwor', { },
				'cha ', { },
				'catr', { },
				'atts', { }
			},
			"text", 'ctxt', plural__,

			"attachment", 'atts',
			"Represents an inline text attachment.  This class is used mainly for make commands.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"file name", 'atfn', 'TEXT',
				"The path to the file for the attachment",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"attachments", 'atts', plural__,

			"paragraph", 'cpar',
			"This subdivides the text into paragraphs.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"paragraphs", 'cpar', plural__,

			"word", 'cwor',
			"This subdivides the text into words.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"words", 'cwor', plural__,

			"character", 'cha ',
			"This subdivides the text into characters.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"characters", 'cha ', plural__,

			"attribute run", 'catr',
			"This subdivides the text into chunks that all have the same attributes.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"attribute runs", 'catr', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		},

		"Keynote Suite",
		"Commands and classes for Keynote Scripting",
		'keyn',
		1,
		1,
		{
			/* Events */

			"zoom",
			"Zoom a window's slide view.",
			'keyn', 'zoom',
			reply_none__,
			'cwin',
			"The window containing the slide view to zoom.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"direction", 'zdir', 'zdop',
				"The direction to zoom.",
				optional,
				singleItem, enumerated, Reserved13,
				"size", 'zsiz', 'ztop',
				"The size to zoom to.",
				optional,
				singleItem, enumerated, Reserved13
			},

			"export",
			"Export a presentation.",
			'keyn', 'expt',
			'file',
			"the exported file",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'docu',
			"The presentaiton to export.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'kfil', 'file',
				"The file to export the presentation to.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"as", 'eptp', 'xtyp',
				"The file type to export the presentation to.",
				required,
				singleItem, enumerated, Reserved13
			}
		},
		{
			/* Classes */

			"window", 'cwin',
			"A keynote presentation window.",
			{
				"<Inheritance>", pInherits, '****',
				"inherits elements and properties of the NSCoreSuite.NSWindow class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"visible slide", 'csld', 'ksld',
				"The currently visible slide.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"master slides are visible", 'vmst', 'bool',
				"Controls whether or not master slides are visible.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"notes are visible", 'vspk', 'bool',
				"Controls whether or not notes are visible.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"layout", 'wvie', 'vieo',
				"Controls the layout style of the window.",
				reserved, singleItem, enumerated, readWrite, Reserved12
			},
			{
			},
			"windows", 'cwin', plural__,

			"document", 'kpre',
			"A keynote presentation document.",
			{
				"<Inheritance>", pInherits, '****',
				"inherits elements and properties of the NSCoreSuite.NSDocument class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"autoplay", 'aupl', 'bool',
				"The presentation's autoplay flag.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'ksld', { }
			},
			"documents", 'kpre', plural__,

			"slide", 'ksld',
			"A slide in a presentation.",
			{
				"<Inheritance>", pInherits, 'cobj',
				"inherits elements and properties of the item class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"title bullet", 'sttl', 'kblt',
				"The slide's title bullet.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"autobuild", 'sabl', 'bool',
				"The slide's autobuild flag.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"speakernotes", 'sspk', '****',
				"The slide's speaker's notes.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"collapsed", 'scps', 'bool',
				"The slide's collapsed flag.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"collapsible", 'sclp', 'bool',
				"Indicates if the slide can be collapsed.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"expandable", 'sexp', 'bool',
				"Indicates if the slide is expandable.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"hidden", 'shid', 'bool',
				"The slide's hidden flag.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'kblt', { },
				'****', { }
			},
			"slides", 'ksld', plural__,

			"bullet", 'kblt',
			"A bullet item in a presentation.",
			{
				"<Inheritance>", pInherits, '****',
				"inherits elements and properties of the NSCoreSuite.AbstractObject class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"content", 'btxt', '****',
				"The bullet's text content.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"spacing", 'bspc', 'nmbr',
				"The bullet's spacing.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"collapsed", 'bclp', 'bool',
				"The bullet's collapsed flag.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"bullets", 'kblt', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'vieo',
			{
				"slide only", 'slds', "Show slides only.",
				"slide and navigator", 'slnv', "Show slides and navigator.",
				"slide and outline", 'slou', "Show slides and outline."
			},

			'ztop',
			{
				"fit in window", 'zfit', "Fit in window.",
				"0.25", 'z25 ', "25% of the slide's size.",
				"0.50", 'z50 ', "Half of the slide's size.",
				"0.75", 'z75 ', "75% of the slide's size.",
				"1.00", 'z100', "The slide's actual size.",
				"2.00", 'z200', "Twice the slide's size."
			},

			'zdop',
			{
				"larger", 'zdin', "Zoom in to increase magnification.",
				"smaller", 'zdou', "Zoom out to decrease magnification."
			},

			'xtyp',
			{
				"PowerPoint", 'ppt ', "Microsoft PowerPoint presentation.",
				"PDF", 'pdf ', "Adobe PDF document.",
				"QuickTime movie", 'moov', "QuickTime movie.",
				"TIFF images", 'tiff', "TIFF images."
			}
		}
	}
};
